=== debian/CMakeLists.txt ===
# These files (generated by dhelpers) will be copied into the control-part of the deb.
# Files that end up in the filesystem normally (e.g. cron/init-scripts) must not be mentioned here.
# It's a good idea to add "conffiles", as the debhelpers may generate it.
set( DH_GENERATED_CONTROL_EXTRA
    preinst
        postinst
        postrm
        prerm
        conffiles
)

# At this point, CMakeDebHelper must be included (add .cmake if you have it in this directory)

include( CMakeDebHelper )

# CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA and CPACK_INSTALL_SCRIPT are set now, don't modify them!
