=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_usrlocal:

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_install:
	install -D -m 644 build/output/libpaho-mqtt3c.so.1.0 $$(pwd)/debian/libpahomqttc/usr/local/lib
	install -D -m 644 build/output/libpaho-mqtt3cs.so.1.0 $$(pwd)/debian/libpahomqttc/usr/local/lib
	install -D -m 644 build/output/libpaho-mqtt3a.so.1.0 $$(pwd)/debian/libpahomqttc/usr/local/lib
	install -D -m 644 build/output/libpaho-mqtt3as.so.1.0 $$(pwd)/debian/libpahomqttc/usr/local/lib
	install -D build/output/paho_c_version $$(pwd)/debian/libpahomqttc/usr/local/bin/paho_c_version
	install -D -m 644 src/MQTTAsync.h $$(pwd)/debian/libpahomqttc/usr/local/include
	install -D -m 644 src/MQTTClient.h $$(pwd)/debian/libpahomqttc/usr/local/include
	install -D -m 644 src/MQTTClientPersistence.h $$(pwd)/debian/libpahomqttc/usr/local/include
	install -D -m 644 src/MQTTProperties.h $$(pwd)/debian/libpahomqttc/usr/local/include
	install -D -m 644 src/MQTTReasonCodes.h $$(pwd)/debian/libpahomqttc/usr/local/include
	install -D -m 644 src/MQTTSubscribeOpts.h $$(pwd)/debian/libpahomqttc/usr/local/include
